/* --- app-phonegap.js ----- */

define(['jquery'], function($) {

	$(document).one('app.extend', function(e, app) {
		
		/*
		 * === CONNECTION =====
		 */

		var connectionTypes;

		function getConnectionTypes() {
			if (typeof Connection !== 'undefined' && navigator.connection && navigator.connection.type) {
				connectionTypes = (function(Connection) {
					var	trans = app.trans;
					var transConnection = trans.connection || {};
					var connections = {
						UNKNOWN:  transConnection.unknown,
						ETHERNET: 'Ethernet connection',
						WIFI:     'WiFi connection',
						CELL_2G:  'Cell 2G connection',
						CELL_3G:  'Cell 3G connection',
						CELL_4G:  'Cell 4G connection',
						NONE:     false
					};
					var types = {};

					for (var type in connections) {
						if (connections.hasOwnProperty(type)) {
							types[Connection[type]] = transConnection[type.toLowerCase()] || connections[type];
						}
					}
					return types;
				}(Connection));
			}
		}

		// --- app.connection.getType ----- //
		app.connection.getType = function() {
			connectionTypes = connectionTypes || getConnectionTypes();

			return navigator.connection && navigator.connection.type && connectionTypes[navigator.connection.type] || '?';
		}


		/*
		 * === NAVIGATION =====
		 */

		// --- app.navigation.gotoUrl ----- //
		app.navigation.gotoUrl = function(url) {
			$.mobile.changePage(url);
		}
	
		// --- app.navigation.openInAppBrowser ----- //
		app.navigation.openInAppBrowser = function(e, url, target, features) {
			if (typeof e === 'string') {
				features = target;
				target = url;
				url = e;
			} else {
				e.stopImmediatePropagation();
				e.preventDefault();
			}
			target	= target || '_system';
			features = features || 'location=yes';
			
			return app.navigation.openUrl(url, target, features);
		}

		$(document).on('click', 'a', function(e) {
			if ($(this).is('[href^="http://"], [href^="https://"], .link-download a')) {
				app.navigation.openInAppBrowser(e, this.href);
			}
		});
	});

});